//
//  ViewController.m
//  PageContainerPlay
//
//  Created by Caylan Larson on 2/21/15.
//  Copyright (c) 2015 Semireg Industries. All rights reserved.
//

#import "ViewController.h"
#import "SemiPageCell.h"

#define SemiPageCellID @"SemiPageCellID"

@interface ViewController () <SemiPageCellDelegate>
@property (strong, nonatomic) IBOutlet IGGridView *grid;
@property (strong, nonatomic) UIView *locView;
@property (nonatomic, readonly) NSInteger pageCount;
@end

@implementation ViewController

-(BOOL)prefersStatusBarHidden
{
    return YES;
}

- (void)viewDidLoad {
    [super viewDidLoad];
    
    self.view.backgroundColor = [UIColor whiteColor];
    
    self.grid = [[IGGridView alloc]initWithFrame:self.view.bounds]; //[[IGGridView alloc] initWithFrame:self.view.bounds style:IGGridViewStyleSingleCellPaging];
    self.grid.autoresizingMask = UIViewAutoresizingFlexibleHeight | UIViewAutoresizingFlexibleWidth;
    [self.view addSubview:self.grid];
    self.grid.delegate = self;
    //[self.grid registerClass:[SemiPageCell class] forCellReuseIdentifier:SemiPageCellID];
    self.grid.dataSource = self;
    self.grid.selectionType = IGGridViewSelectionTypeCell;
    
    [self.grid selectCellAtPath:[IGCellPath pathForRow:10 inSection:0 inColumn:0] animated:YES scrollPosition:IGGridViewScrollPositionBottomLeft];
    
    self.locView = [UIView new];
    self.locView.backgroundColor = [UIColor blueColor];
    [self.view addSubview:self.locView];
}

-(void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
}


-(NSInteger)pageCount
{
    return 3;
}

-(NSInteger)numberOfColumnsInGridView:(IGGridView *)gridView
{
    return self.pageCount;
}

-(NSInteger)gridView:(IGGridView *)gridView numberOfRowsInSection:(NSInteger)section
{
    return 50;
}

-(IGGridViewCell*)gridView:(IGGridView *)gridView cellAt:(IGCellPath *)path
{
    /*SemiPageCell *cell = [gridView dequeueReusableCellWithIdentifier:SemiPageCellID];
    cell.textLabel.text = [NSString stringWithFormat:@"Cell %@", @(path.columnIndex)];
    cell.delegate = self;
    return cell;*/
    
    IGGridViewCell* cell = [gridView dequeueReusableCellWithIdentifier:@"cell"];
    if(!cell)
        cell = [[IGGridViewCell alloc]initWithReuseIdentifier:@"cell"];
    
    cell.textLabel.text = path.description;
    
    return cell;
    
}

-(void)pageCell:(SemiPageCell *)cell centerChanged:(CGFloat)center
{
    IGCellPath *cellPath = [self.grid pathForCell:cell];
    NSLog(@"cellPath:%@ center:%@", cellPath, @(center));
}


/*-(void)scrollViewDidScroll:(UIScrollView *)scrollView
{
    CGFloat locViewWidth = 30;
    
    CGFloat width = self.view.frame.size.width;
    CGFloat dividerWidth = width / (CGFloat)self.pageCount;
    CGFloat percent = self.grid.contentOffset.x / self.grid.contentSize.width;
    if(isnan(percent))
        percent = 0;
    CGFloat startLocation = percent * width;
    
    self.locView.frame = CGRectMake(startLocation + dividerWidth/2.0 - locViewWidth/2.0, 50, locViewWidth, locViewWidth);
    
    NSLog(@"offset:%@", NSStringFromCGPoint(scrollView.contentOffset));
}*/


@end
